﻿Option Strict On
Imports System.Xml.Linq
Imports System.IO
Imports System.IO.IsolatedStorage
Partial Public Class DataInPage
    Inherits PhoneApplicationPage

    Public Sub New()
        InitializeComponent()
    End Sub

    Protected Overrides Sub OnNavigatedTo(e As System.Windows.Navigation.NavigationEventArgs)
        recorddateTextBox.Text = DateTime.Now.ToShortDateString

        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        If storage.DirectoryExists("RecordBloodPressure") = False Then
            storage.CreateDirectory("RecordBloodPressure")
        End If
        Dim filePath As String = Path.Combine("RecordBloodPressure", "BloodPressure.xml")
        If storage.FileExists(filePath) = True Then
            Dim myStream As IsolatedStorageFileStream = storage.OpenFile(filePath, FileMode.Open, FileAccess.Read)
            Using reader As StreamReader = New StreamReader(myStream, System.Text.Encoding.UTF8)
                Dim readXmldoc As String = reader.ReadToEnd
                Dim doc As XElement = XElement.Parse(readXmldoc)
                Dim query = From c In doc.Descendants("情報") Select c.Element("記録日")
                If query.Count > 0 Then
                    ichiranButton.IsEnabled = True
                Else
                    ichiranButton.IsEnabled = False
                End If
            End Using
        End If

        MyBase.OnNavigatedTo(e)
    End Sub

    Private Sub recordButton_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles recordButton.Click
        Dim myDoc As XElement
        Dim filePath As String = Path.Combine("RecordBloodPressure", "BloodPressure.xml")
        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        Dim _myStream As IsolatedStorageFileStream = storage.OpenFile(filePath, FileMode.Open, FileAccess.Read)
        Using reader As StreamReader = New StreamReader(_myStream, System.Text.Encoding.UTF8)
            Dim readXmldoc As String = reader.ReadToEnd
            myDoc = XElement.Parse(readXmldoc)
        End Using

        Dim dateQueryStr As String = myDoc.Descendants("情報").Elements("記録日").Last.Value

        Dim date1 As Date = Date.Parse(recorddateTextBox.Text)
        Dim date2 As Date = Date.Parse(dateQueryStr)

        Dim result As Integer = Date.Compare(date1, date2)

        If result = -1 Then
            MessageBox.Show("現在記録済みの日付より前日のデータは入力できません")
            Exit Sub
        End If

        Try
            Dim high As Integer = System.Convert.ToInt16(highTextBox.Text)
            Dim low As Integer = System.Convert.ToInt16(lowTextBox.Text)
        Catch
            MessageBox.Show("数値を入力してください。")
            Exit Sub
        End Try

        If highTextBox.Text = String.Empty OrElse lowTextBox.Text = String.Empty Then
            Exit Sub
        Else
            If storage.DirectoryExists("RecordBloodPressure") = False Then
                storage.CreateDirectory("RecordBloodPressure")
            End If

            If storage.FileExists(filePath) = False Then
                Dim xmldoc As XDocument = <?xml version="1.0" encoding="utf-8"?>
                                          <血圧記録>
                                              <情報>
                                                  <記録日><%= recorddateTextBox.Text %></記録日>
                                                  <最高血圧><%= highTextBox.Text %></最高血圧>
                                                  <最低血圧><%= lowTextBox.Text %></最低血圧>
                                              </情報>
                                          </血圧記録>

                Using stream As IsolatedStorageFileStream = storage.CreateFile(filePath)
                End Using
                'stream.Dispose()
                If storage.FileExists(filePath) = True Then
                    Using writer As StreamWriter = New StreamWriter(storage.OpenFile(filePath, FileMode.Open, FileAccess.Write))
                        writer.Flush()
                        writer.Write(xmldoc.ToString)
                        'writer.Dispose()
                        MessageBox.Show("保存しました。")
                        ichiranButton.IsEnabled = True
                    End Using
                End If
            Else
                Dim myStream As IsolatedStorageFileStream = storage.OpenFile(filePath, FileMode.Open, FileAccess.Read)
                Using reader As StreamReader = New StreamReader(myStream, System.Text.Encoding.UTF8)
                    Dim readXmldoc As String = reader.ReadToEnd
                    Dim doc As XElement = XElement.Parse(readXmldoc)

                    Dim query = From c In doc.Descendants("情報") Where c.Element("記録日").Value.Equals(recorddateTextBox.Text) Select c
                    If query.Count > 0 Then
                        MessageBox.Show("血圧は記録済みです。")
                        Exit Sub
                    End If

                    Dim addXml As XElement = <情報>
                                                 <記録日><%= recorddateTextBox.Text %></記録日>
                                                 <最高血圧><%= highTextBox.Text %></最高血圧>
                                                 <最低血圧><%= lowTextBox.Text %></最低血圧>
                                             </情報>

                    doc.Add(addXml)
                    'reader.Dispose()
                    myStream.Close()

                    If storage.FileExists(filePath) = True Then
                        Using writer As StreamWriter = New StreamWriter(storage.OpenFile(filePath, FileMode.Open, FileAccess.Write))
                            writer.Flush()
                            writer.Write(doc.ToString)
                            'writer.Close()
                            MessageBox.Show("保存しました。")
                            ichiranButton.IsEnabled = True
                        End Using
                    End If
                End Using
            End If
        End If
    End Sub

    Private Sub ichiranButton_Click(sender As System.Object, e As System.Windows.RoutedEventArgs) Handles ichiranButton.Click
        NavigationService.Navigate(New Uri("/MainPage.xaml", UriKind.Relative))
    End Sub
End Class
