﻿Option Strict On
Imports System.Windows.Documents
Imports System.Windows.Input
Imports System.Windows.Media
Imports System.Windows.Media.Animation

Imports Microsoft.Phone.Controls
'Imports AmCharts
Imports System.Xml.Linq
Imports System.Collections.ObjectModel
Imports System.IO
Imports System.IO.IsolatedStorage

Public Class BloodPressure
    Property 記録日 As String
    Property 最高血圧 As Integer
    Property 最低血圧 As Integer
End Class

'Public Class BloodPressure2
'    Property 記録日 As String
'    Property 最高血圧 As Integer
'    Property 最低血圧 As Integer
'End Class

Partial Public Class MainPage
    Inherits PhoneApplicationPage
    ' コンストラクター
    Public Sub New()
        InitializeComponent()

        ' ListBox コントロールのデータ コンテキストをサンプル データに設定します
        DataContext = App.ViewModel
    End Sub

    ' ViewModel Items のデータを読み込みます
    Dim xmldoc As XElement
    Dim number As Integer = 4
    Dim no1 As Integer = 0
    Dim no2 As Integer = 0
    Dim Index As Integer = 0
    Dim myIndex As Integer = 0
    Dim myPivotItem2 As PivotItem
    Dim myPivo As New PivotItem

    Dim startPos As Integer = 0
    Dim endPos As Integer = 3

    Dim myBloodPressureList As New ObservableCollection(Of BloodPressure)
    'Dim myBloodPressureList2 As New ObservableCollection(Of BloodPressure2)
    Private Sub MainPage_Loaded(ByVal sender As Object, ByVal e As RoutedEventArgs) Handles Me.Loaded
        If Not App.ViewModel.IsDataLoaded Then
            App.ViewModel.LoadData()
        End If

    End Sub

    Protected Overrides Sub OnNavigatedTo(e As System.Windows.Navigation.NavigationEventArgs)

        Dim storage As IsolatedStorageFile = IsolatedStorageFile.GetUserStoreForApplication
        Dim filePath As String = Path.Combine("RecordBloodPressure", "BloodPressure.xml")
        If storage.FileExists(filePath) = True Then

            Using myStream As IsolatedStorageFileStream = storage.OpenFile(filePath, FileMode.Open, FileAccess.Read)
                Using reader As StreamReader = New StreamReader(myStream, System.Text.Encoding.UTF8)
                    Dim readXmldoc As String = reader.ReadToEnd
                    xmldoc = XElement.Parse(readXmldoc)
                End Using
            End Using
            FirstShow()
        Else
            If storage.DirectoryExists("RecordBloodPressure") = False Then
                storage.CreateDirectory("RecordBloodPressure")
            End If
            If storage.FileExists(filePath) = False Then
                Dim xmldoc As XDocument = <?xml version="1.0" encoding="utf-8"?>
                                          <血圧記録></血圧記録>

                Using stream As IsolatedStorageFileStream = storage.CreateFile(filePath)
                End Using
                'stream.Dispose()
                If storage.FileExists(filePath) = True Then
                    Using writer As StreamWriter = New StreamWriter(storage.OpenFile(filePath, FileMode.Open, FileAccess.Write))
                        writer.Flush()
                        writer.Write(xmldoc.ToString)
                    End Using
                    NavigationService.Navigate(New Uri("/DataInPage.xaml", UriKind.Relative))
                End If
            End If

        End If
        MyBase.OnNavigatedTo(e)
    End Sub
    Private Sub FirstShow()
     
        Dim query = From c In xmldoc.Descendants("情報") Select c

        Dim queryCount = From c In xmldoc.Descendants("情報") Select c.Element("記録日")
        If queryCount.Count <= 0 Then
            NavigationService.Navigate(New Uri("/DataInPage.xaml", UriKind.Relative))
            Exit Sub
        End If

        If query.Count < 4 Then
            endPos = query.Count - 1
        Else
            endPos = 3
        End If
        Dim day1 = xmldoc.Descendants("情報")(startPos).Element("記録日").Value
        Dim day2 = xmldoc.Descendants("情報")(endPos).Element("記録日").Value
        Dim myPivotItem As New PivotItem

        myPivotItem.Header = day1 & "から" & day2

        Dim mainChart As New AmCharts.Windows.QuickCharts.SerialChart
        Dim chart As New AmCharts.Windows.QuickCharts.ColumnGraph
        Dim chart2 As New AmCharts.Windows.QuickCharts.ColumnGraph

        chart.Title = "最高血圧"
        chart.Brush = New SolidColorBrush(Colors.Blue)
        chart.ValueMemberPath = "最高血圧"

        chart2.Title = "最低血圧"
        chart2.Brush = New SolidColorBrush(Colors.Yellow)
        chart2.ValueMemberPath = "最低血圧"

        mainChart.AxisForeground = New SolidColorBrush(Colors.Red)
        mainChart.PlotAreaBackground = New SolidColorBrush(Colors.Gray)

        mainChart.CategoryValueMemberPath = "記録日"
        mainChart.DataSource = Data
        mainChart.Graphs.Add(chart)
        mainChart.Graphs.Add(chart2)
        myBloodPressureList.Clear()
        For Each result In query.Take(4)

            With myBloodPressureList
                .Add(New BloodPressure With {.記録日 = result.Element("記録日").Value, .最高血圧 = CInt(result.Element("最高血圧").Value), .最低血圧 = CInt(result.Element("最低血圧").Value)})
            End With

            myPivotItem.Content = mainChart
        Next
        Pivot1.Items.Add(myPivotItem)

        '---------------------------------------------------------------------------------------

        For i = 3 To query.Count - 1 Step number
            myPivotItem2 = New PivotItem
            Dim amari As Integer = (query.Count - 1) Mod 4
            If i + number >= query.Count - 1 Then
                i = query.Count - 1
                number = 0
                Dim lastday1 = xmldoc.Descendants("情報")((i + number) - amari).Element("記録日").Value
                Dim lastday2 = xmldoc.Descendants("情報")(i + number).Element("記録日").Value
                Dim myPivotItem3 As New PivotItem
                myPivotItem3.Header = lastday1 & "から" & lastday2
                Pivot1.Items.Add(myPivotItem3)
                Exit For
            Else
                Dim day3 = xmldoc.Descendants("情報")(i + 1).Element("記録日").Value
                Dim day4 = xmldoc.Descendants("情報")(i + number).Element("記録日").Value
                myPivotItem2.Header = day3 & "から" & day4

            End If
            Pivot1.Items.Add(myPivotItem2)
        Next


    End Sub

    Private Sub DataShow()
        'Pivot1.Items.Clear()
        AddHandler Pivot1.LoadingPivotItem, AddressOf Me.pivot1_LoadingPivotItem

    End Sub

    Private Sub pivot1_LoadingPivotItem(sender As Object, e As PivotItemEventArgs)
        Index = Pivot1.SelectedIndex
        If Index >= 0 Then
            Dim query = From c In xmldoc.Descendants("情報") Select c
            Dim amari As Integer = (query.Count) Mod 4
            no1 = Index * 4
            no2 = no1 + 3
            If amari > 0 AndAlso no2 >= query.Count - 1 Then

                no1 = Index * 4
                no2 = query.Count - 1

            End If
        End If


        Dim myPivot As Pivot = DirectCast(sender, Pivot)
        If e.Item Is myPivot.Items(Index) = False Then Exit Sub
        If e.Item Is myPivot.Items(Index) = True Then

            Dispatcher.BeginInvoke(Sub()
                                       'MessageBox.Show("no1=" & no1.ToString & "no2=" & no2.ToString)


                                       For i As Integer = no1 To no2
                                           'myPivo = New PivotItem
                                           Dim mainChart As New AmCharts.Windows.QuickCharts.SerialChart
                                           Dim chart As New AmCharts.Windows.QuickCharts.ColumnGraph
                                           Dim chart2 As New AmCharts.Windows.QuickCharts.ColumnGraph

                                           chart.Title = "最高血圧"
                                           chart.Brush = New SolidColorBrush(Colors.Blue)
                                           chart.ValueMemberPath = "最高血圧"

                                           chart2.Title = "最低血圧"
                                           chart2.Brush = New SolidColorBrush(Colors.Yellow)
                                           chart2.ValueMemberPath = "最低血圧"
                                           mainChart.AxisForeground = New SolidColorBrush(Colors.Red)
                                           mainChart.PlotAreaBackground = New SolidColorBrush(Colors.Gray)
                                           mainChart.CategoryValueMemberPath = "記録日"

                                           mainChart.Graphs.Add(chart)
                                           mainChart.Graphs.Add(chart2)
                                           mainChart.DataSource = Data

                                           With myBloodPressureList
                                               .Add(New BloodPressure With {.記録日 = xmldoc.Descendants("情報")(i).Element("記録日").Value, .最高血圧 = CInt(xmldoc.Descendants("情報")(i).Element("最高血圧").Value), .最低血圧 = CInt(xmldoc.Descendants("情報")(i).Element("最低血圧").Value)})
                                           End With

                                           'mainChart.DataContext = mainChart
                                           e.Item.Content = mainChart
                                       Next
                                   End Sub)

        End If
        'Pivot1.Items.Add(myPivot)
    End Sub


    Public ReadOnly Property Data() As ObservableCollection(Of BloodPressure)
        Get
            Return myBloodPressureList
        End Get
    End Property

    'Public ReadOnly Property Data2() As ObservableCollection(Of BloodPressure2)
    '    Get
    '        Return myBloodPressureList2
    '    End Get
    'End Property


    Private Sub Pivot1_SelectionChanged(sender As Object, e As System.Windows.Controls.SelectionChangedEventArgs) Handles Pivot1.SelectionChanged
        RemoveHandler Pivot1.LoadingPivotItem, AddressOf Me.pivot1_LoadingPivotItem
        myBloodPressureList.Clear()
        DataShow()
    End Sub

    Private Sub DataRecordPage(sender As Object, e As EventArgs)
        NavigationService.Navigate(New Uri("/DataInPage.xaml", UriKind.Relative))
    End Sub

    Private Sub LastDataRecordPage(sender As Object, e As EventArgs)
        Dim query = From c In xmldoc.Descendants("情報") Select c

        'Dim amari2 As Integer = query.Count Mod 4

        'If amari2 > 0 Then
        myIndex = CInt(System.Math.Floor((query.Count - 1) / 4))
        'End If

        Pivot1.SelectedIndex = myIndex
    End Sub
End Class
